<?php

/*
+---------------------------------------------------------------------------+
| Max Media Manager v0.3                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2006 m3 Media Services Limited                         |
| For contact details, see: http://www.m3.net/                              |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
+---------------------------------------------------------------------------+
$Id: affiliate-invocation.php 5168 2006-07-25 07:03:39Z matteo@beccati.com $
*/

// Require the initialisation file
require_once '../../init.php';

error_reporting('E_ALL');

// Required files
require_once MAX_PATH . '/www/admin/config.php';
require_once MAX_PATH . '/www/admin/lib-statistics.inc.php';
require_once MAX_PATH . '/www/admin/lib-zones.inc.php';
require_once MAX_PATH . '/www/admin/lib-size.inc.php';
require_once MAX_PATH . '/lib/max/Admin/Invocation.php';

// Security check
phpAds_checkAccess(phpAds_Admin + phpAds_Agency + phpAds_Affiliate);

/*-------------------------------------------------------*/
/* Affiliate interface security                          */
/*-------------------------------------------------------*/

if (phpAds_isUser(phpAds_Affiliate)) {
    $affiliateid = phpAds_getUserID();
} elseif (phpAds_isUser(phpAds_Agency)) {
    $result = phpAds_dbQuery("
        SELECT
           affiliateid
        FROM
           ".$conf['table']['prefix'].$conf['table']['affiliates']."
        WHERE
             agencyid=".phpAds_getUserID()) or phpAds_sqlDie();
    if (phpAds_dbNumRows($result) == 0) {
        phpAds_PageHeader("2");
        phpAds_Die($strAccessDenied, $strNotAdmin);
    }
}

/*-------------------------------------------------------*/
/* HTML framework                                        */
/*-------------------------------------------------------*/

if (isset($session['prefs']['affiliate-zones.php']['listorder'])) {
    $navorder = $session['prefs']['affiliate-zones.php']['listorder'];
} else {
    $navorder = '';
}
if (isset($session['prefs']['affiliate-zones.php']['orderdirection'])) {
    $navdirection = $session['prefs']['affiliate-zones.php']['orderdirection'];
} else {
    $navdirection = '';
}

if (phpAds_isUser(phpAds_Admin) || phpAds_isUser(phpAds_Agency)) {
    // Get other affiliates
    if (phpAds_isUser(phpAds_Admin)) {
        $query="SELECT * FROM {$conf['table']['prefix']}{$conf['table']['affiliates']}" . phpAds_getAffiliateListOrder($navorder, $navdirection);
    } elseif (phpAds_isUser(phpAds_Agency)) {
        $query="SELECT * FROM {$conf['table']['prefix']}{$conf['table']['affiliates']} WHERE agencyid=$agencyid" . phpAds_getAffiliateListOrder($navorder, $navdirection);
    }
    
    $res = phpAds_dbQuery($query)
        or phpAds_sqlDie();
    
    while ($row = phpAds_dbFetchArray($res)) {
        phpAds_PageContext (
            phpAds_buildAffiliateName ($row['affiliateid'], $row['name']),
            "affiliate-invocation.php?affiliateid=".$row['affiliateid'],
            $affiliateid == $row['affiliateid']
        );
    }
    
    phpAds_PageShortcut($strAffiliateProperties, 'affiliate-edit.php?affiliateid='.$affiliateid, 'images/icon-affiliate.gif');
    phpAds_PageShortcut($strZoneHistory, 'stats-zone-history.php?affiliateid='.$affiliateid.'&zoneid='.$zoneid, 'images/icon-statistics.gif');
    phpAds_PageHeader("4.2.5");
    echo "<img src='images/icon-affiliate.gif' align='absmiddle'>&nbsp;<b>".phpAds_getAffiliateName($affiliateid)."</b><br /><br /><br />";
    phpAds_ShowSections(array("4.2.2", "4.2.3","4.2.4","4.2.5"));
} else {
    if (phpAds_isAllowed(MAX_AffiliateIsReallyAffiliate)) {
        phpAds_PageHeader('2');
    } else {
        $sections = array();
        $sections[] = "2.1";
        if (phpAds_isAllowed(MAX_AffiliateGenerateCode)) {
            $sections[] = "2.2";
        }    
        phpAds_PageHeader('2.2');
        phpAds_ShowSections($sections);
    }
}

/*-------------------------------------------------------*/
/* Main code                                             */
/*-------------------------------------------------------*/

$maxInvocation = new MAX_Admin_Invocation();

$pluginType = phpAds_isUser(phpAds_Affiliate) && phpAds_isAllowed(MAX_AffiliateIsReallyAffiliate) ? 'affiliatePlugin' : 'publisherPlugin';

// Get available publisher invocation types
$invocationTypes = &MAX_Plugin::getPlugins('invocationTags');
foreach($invocationTypes as $pluginKey => $invocationType) {
    if ($invocationType->$pluginType == true) {
        $available[$pluginKey] = $invocationType->$pluginType;
        $names[$pluginKey] = $invocationType->getName();
    }
}

if ($pluginType == 'affiliatePlugin') {

    phpAds_registerGlobal('size', 'text', 'dest');
    
    $size = isset($size) ? $size : 'all';
    
    if (preg_match('/^(\d+)x(\d+)$/D', $size, $matches)) {
        $width  = $matches[1];
        $height = $matches[2];
    } elseif ($size == 'text') {
        $width  = $height = 0;
    } else {
        $width  = $height = -1;
        $size   = 'all';
    }

    $res = phpAds_dbQuery("
        SELECT
            zoneid,
            zonename,
            width,
            height,
            delivery
        FROM
            {$conf['table']['prefix']}{$conf['table']['zones']}
        WHERE
            affiliateid={$affiliateid}
        ") or phpAds_sqlDie();
    
    $aZones = array();
    while ($row = phpAds_dbFetchArray($res)) {
        $aZones[$row['zoneid']] = $row;
    }

    echo "
        <script type='text/javascript'>
        <!--
        function MAX_htmlspecialchars(str)
        {
            str = str.replace(/&/g, '&amp;');
            str = str.replace(/</g, '&lt;');
            str = str.replace(/>/g, '&gt;');
            str = str.replace(/\"/g, '&quot;');
            return str;
        }
        function regenerateTextAd(id)
        {
            var oCode = findObj('bannercode_' + id);
            var oHtml = findObj('bannerhtml_' + id);
            var oText = findObj('text_' + id);
            var oDest = findObj('dest_' + id);
            ";
    
    if (isset($invocationTypes['ar'])) {
        echo "
            var sep = oDest.value.indexOf('?') >= 0 ? '&' : '?';
            oCode.value = oCode.value.replace(new RegExp('(<a href=\\').*?(\\\\?|&|&amp;)(m3_data=)', 'g'), '$1' + MAX_htmlspecialchars(oDest.value + sep) + '$3');";
    } else {
        echo "
            oCode.value = oCode.value.replace(new RegExp('(__maxdest=)[^\\']*', 'g'), '$1' + MAX_htmlspecialchars(oDest.value));";
    }
    
    echo "
            oCode.value = oCode.value.replace(new RegExp('^(<a[^>]+>).*(</a>)$', 'g'), '$1' + MAX_htmlspecialchars(oText.value) + '$2');
            oHtml.innerHTML = oCode.value;
        }
        //-->
        </script>
    ";    

    $aSizes = array();
    $buffer = '';
    foreach ($aZones as $zoneId => $zone) {
        $zoneAds = MAX_Dal_Delivery_getZoneLinkedAds($zoneId);

        $adVarNames = array('xAds', 'ads', 'lAds');
        foreach ($adVarNames as $var) {
            foreach ($zoneAds[$var] as $adId => $ad) {
                if ($ad['type'] == 'txt') {
                    $bannersize = 'Text banner';
                    $aSizes['0x0'] = true;
                } else {
                    $bannersize = $ad['width'].'x'.$ad['height'];
                    $aSizes[$bannersize] = array('width' => $ad['width'], 'height' => $ad['height']);
                    $bannersize = 'Banner size: '.$bannersize;
                }
                
                // Exclude not matching banners
                if (($width > 0 && ($width != $ad['width'] || $height != $ad['height'])) || ($width == 0 && $ad['type'] != 'txt')) {
                    continue;
                }

                if (isset($invocationTypes['ar'])) {
                    $ad    = $invocationTypes['ar']->prepareBannerForArrivals($ad);
                    $dest  = $invocationTypes['ar']->getDestination($ad);

                    $bannercode = MAX_buildBannerHtml($ad, $zoneId, '', '', '', true, $dest, false, true, '', '', '');
                    $bannerhtml = $bannercode;
                } else {
                    if (empty($ad['url'])) {
                        $ad['url'] = '#';
                    }
    
                    $bannercode = MAX_buildBannerHtml($ad, $zoneId, '', '', '', true, true, false, true, '', '', '');
                    $bannerhtml = MAX_buildBannerHtml($ad, $zoneId, '', '', '', true, false, false, true, '', '', '');
                }
                
                if ($ad['contenttype'] == 'swf') {
                    $bannercode = MAX_flashGetFlashObjectExternal() . $bannercode;
                    $bannerhtml = MAX_flashGetFlashObjectExternal() . $bannerhtml;
                }

                if ($ad['url'] == '#') {
                    $ad['url'] = '';
                }

                $codeId = "{$zoneId}_{$adId}";

                $buffer .= "
                    <table border='1' style='width: 700px; margin-bottom: 2em'>
                        <tr>
                            <td colspan='2'><strong>{$zone['zonename']}:</strong> {$ad['name']}</td>
                        </tr>
                        <tr>
                            <td style='width: 350px'>";
                if (strpos ($_SERVER['HTTP_USER_AGENT'], 'MSIE') > 0 && strpos ($_SERVER['HTTP_USER_AGENT'], 'Opera') < 1) {
                    $buffer .= "<table border='0' style='width: 100%'><tr><td align='left'><em>Code:</em></td><td align='right'><img src='images/icon-clipboard.gif' align='absmiddle'>&nbsp;";
                    $buffer .= "<a href='javascript:max_CopyClipboard(\"bannercode_{$codeId}\");'>{$GLOBALS['strCopyToClipboard']}</a></td></tr></table>";
                } else {
                    $buffer .= "Code:";
                }
                $buffer .= "</td>
                            <td style='width: 350px' align='center'><em>Preview ({$bannersize})</em></td>
                        </tr>
                        <tr>
                            <td><textarea style='width: 350px; height: 250px' class='code-gray' name='bannercode_{$codeId}' id='bannercode_{$codeId}'>" . htmlspecialchars($bannercode) . "</textarea></td>
                            ";
                
                if ($ad['type'] == 'txt') {
                    $buffer .= "
                            <td align='center'>
                                <p id='bannerhtml_{$codeId}'>{$bannerhtml}</p>
                                <p>&nbsp;</p>
                                <hr>
                                <p>&nbsp;</p>
                                <form action='' method='get' onsubmit='return false'>
                                    <table border='0'>
                                        <tr><td align='right'><strong>Text:</strong>&nbsp;</td><td><input type='text' name='text_{$codeId}' onfocus='regenerateTextAd(\"{$codeId}\")' onkeyup='regenerateTextAd(\"{$codeId}\")' onblur='regenerateTextAd(\"{$codeId}\")' value='".htmlspecialchars($ad['bannertext'])."' /></td></tr>
                                        <tr><td align='right'><strong>Destination URL:&nbsp;</td><td></strong><input type='text' name='dest_{$codeId}' onfocus='regenerateTextAd(\"{$codeId}\")' onkeyup='regenerateTextAd(\"{$codeId}\")' onblur='regenerateTextAd(\"{$codeId}\")' value='".htmlspecialchars($ad['url'])."' /></td></tr>
                                    </table>
                                </form>
                                <script type='text/javascript'>regenerateTextAd(\"{$codeId}\");</script>
                            </td>";
                } else {
                    $buffer .=     "
                            <td align='center'>
                                <div style='overflow: auto; height: 250px'>
                                    <table border='0' cellspacing='0' cellpadding='0'>
                                        <tr><td style='height: 250px' valign='middle'>{$bannerhtml}</td></tr>
                                    </table>
                                </div>
                            </td>";            
                }
                
                $buffer .= "
                        </tr>
                    </table>
                ";
            }
        }
    }
    
    echo "
        <br />
        <br />
        <form action='' method='get'>
            <input type='hidden' name='affiliateid' value='{$affiliateid}' />
            <b>Banner type:</b> <select name='size' onchange='this.form.submit()' tabindex='".($tabindex++)."'>
                <option value='all'".($width == -1 ? ' selected="selected"' : '').">All</option>
        ";

    if (isset($aSizes['0x0'])) {
        echo "<option value='text'".($width == 0 ? ' selected="selected"' : '').">Text banner</option>";
        unset($aSizes['0x0']);
    }
    
    foreach (array_keys($phpAds_IAB) as $key)
    {
        if (!isset($aSizes[$phpAds_IAB[$key]['width'].'x'.$phpAds_IAB[$key]['height']])) {
            continue;
        }
        unset($aSizes[$phpAds_IAB[$key]['width'].'x'.$phpAds_IAB[$key]['height']]);
        
        $selected = $phpAds_IAB[$key]['width'] == $width && $phpAds_IAB[$key]['height'] == $height;
        echo "<option value='".$phpAds_IAB[$key]['width']."x".$phpAds_IAB[$key]['height']."'".
            ($selected ? 'selected="selected"' : '').">".$key."</option>";
    }
    
    ksort($aSizes);
    foreach ($aSizes as $key => $value) {
        $selected = $value['width'] == $width && $value['height'] == $height;
        echo "<option value='".$key."'".($selected ? 'selected="selected"' : '').">".'Custom'.' ('.str_replace('x', ' x ',$key).")</option>";
    }
    
    echo "
            </select>
        </form>
        ";

    phpAds_ShowBreak();

    echo '<br />';
    echo $buffer;
} else {
    if (count($available) == 1) {
        // Only one publisher invocation plugin available
        $publisherPlugin = array_keys($available);
        $codetype = $publisherPlugin[0];
        $code = $maxInvocation->generateInvocationCode($invocationTag = null);
    } elseif (count($available) > 1) {
        // Multiple publisher invocation plugins available
        if (!empty($_GET['codetype'])) {
            $codetype = $_GET['codetype'];
        } else {
            $publisherPlugin = array_keys($available);
            $codetype = $publisherPlugin[0];
        }
        $code = $maxInvocation->generateInvocationCode($invocationTag = null);
    
        // Show the publisher invocation selection drop down
        echo "<form name='generate' action='".$_SERVER['PHP_SELF']."' method='GET' onSubmit='return max_formValidate(this);'>\n";
        echo "<table border='0' width='100%' cellpadding='0' cellspacing='0'>";
        echo "<input type='hidden' name='affiliateid' value='{$affiliateid}'>";
        echo "<tr><td height='25' colspan='3'><b>". MAX_Plugin_Translation::translate('Please choose the type of invocation', 'invocationTags') ."</b></td></tr>";
        echo "<tr><td height='35'>";
        echo "<select name='codetype' onChange=\"this.form.submit()\" accesskey=".$GLOBALS['keyList']." tabindex='".($tabindex++)."'>";
    
        foreach($names as $pluginKey => $invocationTypeName) {
            echo "<option value='".$pluginKey."'".($codetype == $pluginKey ? ' selected' : '').">".$invocationTypeName."</option>";
        }
    
        echo "</select>";
        echo "&nbsp;<input type='image' src='images/".$phpAds_TextDirection."/go_blue.gif' border='0'>";
        echo "</td></tr></table>";
    
        echo phpAds_ShowBreak($print = false);
        echo "<br />";
        echo '</form>';
    } else {
        // No publisher invocation plugins available
        $code = 'Error: No publisher invocation plugins available';
    }
    if (!empty($codetype)) {
        $code = $maxInvocation->generateInvocationCode($invocationTag = null);
    }
    
    echo "<table border='0' width='550' cellpadding='0' cellspacing='0'>";
    echo "<tr><td height='25'><img src='images/icon-generatecode.gif' align='absmiddle'>&nbsp;<b>".$GLOBALS['strBannercode']."</b></td>";
    
    // Show clipboard button only on IE
    if (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') > 0 && strpos($_SERVER['HTTP_USER_AGENT'], 'Opera') < 1) {
        echo "<td height='25' align='right'><img src='images/icon-clipboard.gif' align='absmiddle'>&nbsp;";
        echo "<a href='javascript:max_CopyClipboard(\"bannercode\");'>".$GLOBALS['strCopyToClipboard']."</a></td></tr>";
    }
    else
    echo "<td>&nbsp;</td>";
    
    echo "<tr height='1'><td colspan='2' bgcolor='#888888'><img src='images/break.gif' height='1' width='100%'></td></tr>";
    
    echo "<tr><td colspan='2'><textarea name='bannercode' class='code-gray' rows='30' cols='80' style='width:800;' readonly>";
    
    echo $code;
    
    echo "</textarea></td></tr>";
    echo "</table><br />";
    
    $previewURL = 'http://' . $conf['webpath']['admin'] . "/affiliate-preview.php?affiliateid={$affiliateid}&codetype={$codetype}";
    
    echo "<strong>Preview URL:</strong> - <a href='{$previewURL}' target='_blank'>{$previewURL}</a>";
    
    phpAds_ShowBreak();
    echo "<br />";
}

/*-------------------------------------------------------*/
/* HTML framework                                        */
/*-------------------------------------------------------*/

phpAds_PageFooter();


?>
